<?php
// vim: foldmethod=marker
/**
 *  EthnaTask_ActionClass.php
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @package    EthnaTask
 *  @version    $Id: app.actionclass.php,v 1.1 2006/08/22 15:52:26 fujimoto Exp $
 */

// {{{ EthnaTask_ActionClass
/**
 *  action¹ԥ饹
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @package    EthnaTask
 *  @access     public
 */
class EthnaTask_ActionClass extends Ethna_ActionClass
{
    var $db;

    function EthnaTask_ActionClass(&$backend)
    {   
        $result = parent::Ethna_ActionClass($backend);
        $this->db = $this->backend->getDB();
        return $result;
    }

    /**
     *  ¹ǧڽԤ
     *
     *  @access public
     *  @return string  ̾(nullʤｪλ, falseʤλ)
     */
    function authenticate()
    {
        if (!$this->session->isStart()) {
            $this->redirect('/login');
        }

        return parent::authenticate();
    }

    /**
     *  ¹ν(եͥå)Ԥ
     *
     *  @access public
     *  @return string  ̾(nullʤｪλ, falseʤλ)
     */
    function prepare()
    {
        return parent::prepare();
    }

    /**
     *  ¹
     *
     *  @access public
     *  @return string  ̾(nullʤܤϹԤʤ)
     */
    function perform()
    {
        return parent::perform();
    }

    function redirect($action = "", $message = "", $wait = 2)
    {
        $wait = (int)$wait;
        if (!strlen($message)) {
            $message = 'Ф餯Ԥ';
        }

        $url = $this->config->get('url') . basename($_SERVER['SCRIPT_NAME']) . $action;
        $html = <<<EOD
<html>
<head>
<meta http-equiv="Content-type" content="text/html; charset=EUC-JP">
<meta http-equiv="refresh" CONTENT="{$wait};URL={$url}">
<meta name="robots" content="INDEX,NOFOLLOW">
<title>Redirecting to {$url}</title>
</head>
<body>
<p>{$message}</p>
<p>
<a href="{$url}">̤ưŪѤʤ祯åƤ</a></p>
</p>
</body>
</html>
EOD;
        print($html);
        exit();
    }

}
// }}}
?>
