<?php
/**
 *  JsonValidate.php
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @package    Ethnatask
 *  @version    $Id: skel.action.php,v 1.9 2006/09/22 09:11:17 ichii386 Exp $
 */

/**
 *  JsonValidateեμ
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @access     public
 *  @package    Ethnatask
 */
class Ethnatask_Form_JsonValidate extends Ethnatask_ActionForm
{
    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = true;
    var $use_csrf_plugin = false;
    var $use_duplicate_post_plugin = false;

    /**
     *  @access private
     *  @var    array   ե
     */
    var $form = array(
        /*
        'sample' => array(
            // ե
            'type'          => VAR_TYPE_INT,    // ͷ
            'form_type'     => FORM_TYPE_TEXT,  // ե෿
            'name'          => 'ץ',      // ɽ̾

            // Хǡ(ҽ˥Хǡ¹Ԥޤ)
            'required'      => true,            // ɬܥץ(true/false)
            'min'           => null,            // Ǿ
            'max'           => null,            // 
            'regexp'        => null,            // ʸ(ɽ)

            // ե륿
            'filter'        => null,            // Ѵե륿ץ
        ),
        */
        'callback' => array(
            'type' => VAR_TYPE_STRING,
            'form_type' => FORM_TYPE_HIDDEN,
            'required' => true,
        ),
        'action' => array(
            'type' => VAR_TYPE_STRING,
            'form_type' => FORM_TYPE_HIDDEN,
            'required' => true,
        ),
    );
}

/**
 *  JsonValidateμ
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @access     public
 *  @package    Ethnatask
 */
class Ethnatask_Action_JsonValidate extends Ethnatask_ActionClass
{
    /**
     *  ե४֥(helper)
     *
     *  @access protected
     */
    function &_getHelperActionForm($action)
    {
        $af = null;
        $ctl =& Ethna_Controller::getInstance();
        $form_name = $ctl->getActionFormName($action);
        if ($form_name == null) {
            // TODO: logging
            return null;
        }
        $af =& new $form_name($ctl);

        //disable csrf and duppost
        $af->use_csrf_plugin = false;
        $af->use_duplicate_post_plugin = false;

        return $af;
    }

    /**
     *  JsonValidate
     *
     *  @access public
     *  @return string      ̾(ｪλʤnull, λʤfalse)
     */
    function prepare()
    {
        $message_list = array();

        $this->af->setApp('action', $this->af->get('action'));

        if ($this->af->validate() == 0) {
            $af = $this->_getHelperActionForm($this->af->get('action'));
            $af->setFormVars();
            if ($af->validate() != 0) {
                foreach ($af->ae->getErrorList() as $error) {
                    $message = $error['object']->getMessage();
                    $error_name = $af->getName($error['name']);
                    $message_list[] = str_replace('{form}', $error_name, $message);
                }
                $this->af->setApp('message_list', $message_list);
                return 'ToJsonp';
            }
        }

        $this->af->setApp('message_list', $this->af->ae->getMessageList());
        return 'ToJsonp';
    }

    /**
     *  JsonValidateμ
     *
     *  @access public
     *  @return string  ̾
     */
    function perform()
    {
        //return 'JsonValidate';
    }
}
?>
