<?php
/**
 *  Login.php
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @package    EthnaTask
 *  @version    $Id: skel.action.php,v 1.10 2006/11/06 14:31:24 cocoitiban Exp $
 */

require_once 'Auth/Hatena.php';

/**
 *  Loginեμ
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @access     public
 *  @package    EthnaTask
 */
class Ethnatask_Form_Login extends EthnaTask_ActionForm
{
    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = true;

    /**
     *  @access private
     *  @var    array   ե
     */
    var $form = array(
        /*
        'sample' => array(
            // ե
            'type'          => VAR_TYPE_INT,    // ͷ
            'form_type'     => FORM_TYPE_TEXT,  // ե෿
            'name'          => 'ץ',      // ɽ̾

            // Хǡ(ҽ˥Хǡ¹Ԥޤ)
            'required'      => true,            // ɬܥץ(true/false)
            'min'           => null,            // Ǿ
            'max'           => null,            // 
            'regexp'        => null,            // ʸ(ɽ)

            // ե륿
            'filter'        => null,            // Ѵե륿ץ
        ),
        */
    );
}

/**
 *  Loginμ
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @access     public
 *  @package    EthnaTask
 */
class Ethnatask_Action_Login extends EthnaTask_ActionClass
{
    /**
     * Hatena API Object
     * @var     Auth_Hatena
     * @access  private
     */
    var $hatena;

    function authenticate()
    {
        //disable authenticate
        return null;
    }

    /**
     *  Login
     *
     *  @access public
     *  @return string      ̾(ｪλʤnull, λʤfalse)
     */
    function prepare()
    {
        $config = $this->config->get('auth');
        $controller =& $this->backend->getController();
        $plugin     =& $controller->getPlugin();
        $this->auth =& $plugin->getPlugin('Auth', ucfirst($config['type']));

        $this->af->setApp('login_url', $this->auth->getLoginUrl());

        return null;
    }

    /**
     *  Loginμ
     *
     *  @access public
     *  @return string  ̾
     */
    function perform()
    {
        $result = $this->auth->login();
        if (!Ethna::isError($result) && $result !== false) {
            $this->redirect();
        }

        return 'login';
    }

}
?>
