<?php
/**
 *  TaskAdd.php
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @package    EthnaTask
 *  @version    $Id: skel.action.php,v 1.10 2006/11/06 14:31:24 cocoitiban Exp $
 */

/**
 *  TaskAddեμ
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @access     public
 *  @package    EthnaTask
 */
class Ethnatask_Form_TaskAdd extends EthnaTask_ActionForm
{
    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = true;

    /**
     *  @access private
     *  @var    array   ե
     */
    var $form = array(
        /*
        'sample' => array(
            // ե
            'type'          => VAR_TYPE_INT,    // ͷ
            'form_type'     => FORM_TYPE_TEXT,  // ե෿
            'name'          => 'ץ',      // ɽ̾

            // Хǡ(ҽ˥Хǡ¹Ԥޤ)
            'required'      => true,            // ɬܥץ(true/false)
            'min'           => null,            // Ǿ
            'max'           => null,            // 
            'regexp'        => null,            // ʸ(ɽ)

            // ե륿
            'filter'        => null,            // Ѵե륿ץ
        ),
        */
        'post' => array(
            'name' => 'Ͽ',
            'form_type' => 'submit',
        ),
        'name' => array(
            'name' => '',
            'type' => VAR_TYPE_STRING,
            'form_type' => FORM_TYPE_TEXT,
            'required' => true,
        ),
        'comment' => array(
            'name' => 'ܺ',
            'type' => VAR_TYPE_STRING,
            'form_type' => FORM_TYPE_TEXTAREA,
            'required' => false,
        ),
        'rate' => array(
            'name' => 'ͥ',
            'type' => VAR_TYPE_INT,
            'max' => 1000,
            'required' => false,
            'form_type' => FORM_TYPE_SELECT,
        ),
    );
}

/**
 *  TaskAddμ
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @access     public
 *  @package    EthnaTask
 */
class Ethnatask_Action_TaskAdd extends EthnaTask_ActionClass
{
    /**
     *  TaskAdd
     *
     *  @access public
     *  @return string      ̾(ｪλʤnull, λʤfalse)
     */
    function prepare()
    {
        $this->af->form['rate']['option'] = range(0,100);

        if (!$this->af->get('post')) {
            return 'task-add';
        } else if ($this->af->validate() == 0) {
            return null;
        } else {
            return 'task-add';
        }
    }

    /**
     *  TaskAddμ
     *
     *  @access public
     *  @return string  ̾
     */
    function perform()
    {
        $param = $this->af->getArray();
        $param['user'] = $this->session->get("name");
        $this->db->addTask($param);
        $this->redirect('/task/add', "Ͽޤ", 2);
    }
}
?>
