<?php
/**
 *  EthnaTask_Plugin_Filter_ExecutionTime.php
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @package    EthnaTask
 *  @version    $Id: app.plugin.filter.default.php,v 1.2 2006/11/06 14:31:24 cocoitiban Exp $
 */

/**
 *  ¹Իַ¬ե륿ץ饰μ
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @access     public
 *  @package    EthnaTask
 */
class EthnaTask_Plugin_Filter_ExecutionTime extends Ethna_Plugin_Filter
{
    /**#@+
     *  @access private
     */

    /**
     *  @var    int     ϻ
     */
    var $stime;

    /**#@-*/


    /**
     *  ¹ե륿
     *
     *  @access public
     */
    function preFilter()
    {
        $stime = explode(' ', microtime());
        $stime = $stime[1] + $stime[0];
        $this->stime = $stime;
    }

    /**
     *  ¹ե륿
     *
     *  @access public
     *  @param  string  $action_name    ¹Ԥ륢̾
     *  @return string  null:ｪλ (string):¹Ԥ륢̾ѹ
     */
    function preActionFilter($action_name)
    {
        return null;
    }

    /**
     *  ¹Ըե륿
     *
     *  @access public
     *  @param  string  $action_name    ¹Ԥ줿̾
     *  @param  string  $forward_name   ¹Ԥ줿󤫤
     *  @return string  null:ｪλ (string):̾ѹ
     */
    function postActionFilter($action_name, $forward_name)
    {
        return null;
    }

    /**
     *  ¹Ըե륿
     *
     *  @access public
     */
    function postFilter()
    {
        $etime = explode(' ', microtime());
        $etime = $etime[1] + $etime[0];
        $time   = round(($etime - $this->stime), 4);

        print "\n<!-- page was processed in $time seconds -->\n";
    }
}
?>
