<?php
/**
 *  Haste_Plugin_FormType_Sortablelist.php
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @package    Haste
 *  @version    $Id: app.plugin.filter.default.php,v 1.2 2006/11/06 14:31:24 cocoitiban Exp $
 */

/**
 *  Haste_Plugin_FormType_Sortablelist
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @access     public
 *  @package    Haste
 */
class Haste_Plugin_FormType_Sortablelist
{
    /**#@+
     *  @access private
     */

    /**#@-*/

    /**
     *  Haste_Plugin_FormType_Sortablelist
     *
     *  @access public
     *  @param  object  Ethna_Controller    &$controller    ȥ饪֥
     */
    function Haste_Plugin_FormType_Sortablelist(&$controller)
    {
        // ֥Ȥ
        $this->controller =& $controller;
        $this->ctl =& $this->controller;

        $this->config =& $controller->getConfig();
        $this->logger =& $this->controller->getLogger();
    }

    /**
     *  fetch
     *
     *  @access public
     *  @return string
     */
    function fetch($name, $def, $params)
    {
        $input = '<input type="hidden"';
        $input.= " name=\"{$name}\" id=\"actionform_{$name}\" />";
        $js_header = <<<EOD
<script language="JavaScript" type="text/javascript">
<!--
function populateHiddenVars() {
    var list = Sortable.sequence('sortablelist_{$name}');
    list.reverse();
    node = document.getElementById('actionform_{$name}');
    while (value = list.pop()) {
        var input = document.createElement("input");
        input.setAttribute("type", "hidden");
        input.setAttribute("name", "{$name}[]");
        input.setAttribute("value", value);
        node.parentNode.insertBefore(input, node);
    }
    node.parentNode.removeChild(node);
    return true;
}
//-->
</script>
EOD;
        if (is_array($def['option'])) {
            $list = "<ul id=\"sortablelist_{$name}\">\n";
            foreach ($def['option'] as $key => $value) {
                $list .= "<li id=\"item_{$key}\">{$value}</li>\n";
            }
            $list .= "</ul>\n";
            $js_footer = <<<EOD
<script type="text/javascript">
Sortable.create('sortablelist_{$name}',{tag:'li'});
</script>
EOD;
            $input = $js_header . $input . $list . $js_footer;
        }
        return $input;
    }

}
?>
