<?php
/**
 *  EthnaTask_UrlHandler.php
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @package    EthnaTask
 *  @version    $Id: app.url_handler.php,v 1.2 2006/11/06 14:31:24 cocoitiban Exp $
 */

/**
 *  URLϥɥ饯饹
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @access     public
 *  @package    EthnaTask
 */
class EthnaTask_UrlHandler extends Ethna_UrlHandler
{
    /** @var    array   ޥåԥ */
    var $action_map = array(
        /*
        'user'  => array(
            'user_login' => array(
                'path'          => 'login',
                'path_regexp'   => false,
                'path_ext'      => false,
                'option'        => array(),
            ),
        ),
         */
        'task' => array(
            'task' => array(
                'path'        => 'task',
                'path_regexp' => '|task/([\d]+)$|',
                'path_ext'    => array('id' => array()),
            ),
            'rss' => array(
                'path'        => 'rss',
                'path_regexp' => '|rss/(.*)$|',
                'path_ext'    => array('user' => array()),
            ),
            'jsonvalidate' => array(
                'path'          => 'json/validate',
                'path_regexp'   => '/json\/validate\/(.*)/',
                'path_ext'      => array(
                    'action' => array(),
                    ),
                'option'        => array(),
            ),
            'taskadd' => array(
                'path'          => 'task/add',
            ),
            'login' => array(
                'path'          => 'login',
            ),
            'logout' => array(
                'path'          => 'logout',
            ),
         ),
    );

    /**
     *  EthnaTask_UrlHandler饹Υ󥹥󥹤
     *
     *  @access public
     */
    function &getInstance($class_name = null)
    {
        $instance =& parent::getInstance(__CLASS__);
        return $instance;
    }

    // {{{ ȥꥯ
    /**
     *  ꥯ(userȥ)
     *
     *  @access private
     */
    /*
    function _normalizeRequest_User($http_vars)
    {
        return $http_vars;
    }
     */
    // }}}

    // {{{ ȥѥ
    /**
     *  ѥ(userȥ)
     *
     *  @access private
     */
    /*
    function _getPath_User($action, $param)
    {
        return array("/user", array());
    }
     */
    // }}}

    // {{{ ե륿
    // }}}
}

// vim: foldmethod=marker tabstop=4 shiftwidth=4 autoindent
?>
