<?php
/**
 *  Index.php
 *
 *  @author    halt <halt.feits@gmail.com>
 *  @package   EthnaTask
 *  @version   $Id: app.action.default.php,v 1.15 2006/11/06 14:31:24 cocoitiban Exp $
 */

/**
 *  indexեμ
 *
 *  @author    halt <halt.feits@gmail.com>
 *  @access    public
 *  @package   EthnaTask
 */

class EthnaTask_Form_Index extends EthnaTask_ActionForm
{
    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = false;

    /**
     *  @access   private
     *  @var      array   ե
     */
     var $form = array(
       /*
        *  TODO: Υ󤬻Ѥե򵭽ҤƤ
        *
        *  (typeƤǤϾάǽ)
        *
        *  'sample' => array(
        *  // ե
        *      'type'        => VAR_TYPE_INT,        // ͷ
        *      'form_type'   => FORM_TYPE_TEXT,      // ե෿
        *      'name'        => 'ץ',          // ɽ̾
        *  
        *  // Хǡ(ҽ˥Хǡ¹Ԥޤ)
        *      'required'    => true,                        // ɬܥץ(true/false)
        *      'min'         => null,                        // Ǿ
        *      'max'         => null,                        // 
        *      'regexp'      => null,                        // ʸ(ɽ)
        *
        *  // ե륿
        *      'filter'      => null,                        // Ѵե륿ץ
        *  ),
        */
         'tasklist' => array(
             'name' => "Task List",
             'form_type' => 'sortablelist',
             'type' => array(VAT_TYPE_STRING),
         ),
         'submit' => array(
             'name' => "ѹ¸",
             'form_type' => 'submit',
             'type' => VAT_TYPE_STRING,
         ),
      );
}

/**
 *  indexμ
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @access     public
 *  @package    EthnaTask
 */
class EthnaTask_Action_Index extends EthnaTask_ActionClass
{
        /**
         *  index
         *
         *  @access    public
         *  @return    string  Forward(ｪλʤnull)
         */
        function prepare()
        {
            $tasklist = $this->af->getDef("tasklist");
            $result = $this->db->getRecentTaskFromUser($this->session->get('name'));
            $list = array();
            if (is_array($result)) {
                foreach ($result as $task) {
                    $value = "{$task['name']} &nbsp;";
                    $value.= "<a href=\"";
                    $value.= $this->config->get('url');
                    $value.= basename($_SERVER['SCRIPT_NAME']) . "/task/{$task['id']}\">ܺ</a>";
                    $list[$task['task_order']] = $value;
                }
            }
            $tasklist['option'] = $list;
            $this->af->setDef("tasklist", $tasklist);

            if (!$this->af->get('submit')) {
                return 'index';
            } else if ($this->af->validate() == 0) {
                return null;
            } else {
                return 'index';
            }
        }

        /**
         *  indexμ
         *
         *  @access    public
         *  @return    string  ̾
         */
        function perform()
        {
            $task_list = $this->af->form['tasklist']['option'];
            $response_list = $this->af->get('tasklist');

            $base = array_keys($task_list);
            $this->db->replaceOrder($base, $response_list);

            $this->redirect("", 'ѹޤ', 2);
            return null;
        }
}
?>
