<?php
/**
 *  Rss.php
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @package    EthnaTask
 *  @version    $Id: skel.action.php,v 1.10 2006/11/06 14:31:24 cocoitiban Exp $
 */

/**
 *  Rssեμ
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @access     public
 *  @package    EthnaTask
 */
class Ethnatask_Form_Rss extends EthnaTask_ActionForm
{
    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = true;

    /**
     *  @access private
     *  @var    array   ե
     */
    var $form = array(
        /*
        'sample' => array(
            // ե
            'type'          => VAR_TYPE_INT,    // ͷ
            'form_type'     => FORM_TYPE_TEXT,  // ե෿
            'name'          => 'ץ',      // ɽ̾

            // Хǡ(ҽ˥Хǡ¹Ԥޤ)
            'required'      => true,            // ɬܥץ(true/false)
            'min'           => null,            // Ǿ
            'max'           => null,            // 
            'regexp'        => null,            // ʸ(ɽ)

            // ե륿
            'filter'        => null,            // Ѵե륿ץ
        ),
        */
        'user' => array(),
    );
}

/**
 *  Rssμ
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @access     public
 *  @package    EthnaTask
 */
class Ethnatask_Action_Rss extends EthnaTask_ActionClass
{
    function authenticate()
    {
        return null;
    }

    /**
     *  Rss
     *
     *  @access public
     *  @return string      ̾(ｪλʤnull, λʤfalse)
     */
    function prepare()
    {
        //ex. http://example.com/ep.php/rss/[user]
        $result = $this->db->getRecentTaskFromUser($this->af->get('user'));
        $rows = array();
        foreach ($result as $row) {
            $row['created_at'] = date('r', $row['created_at']);
            foreach ($row as $key => $param) {
                $row[$key] = mb_convert_encoding($param, 'UTF-8', 'EUC-JP');
            }
            $rows[] = $row;
        }
        $this->af->setApp("tasks", $rows);

        header("Content-type: text/xml;charset=utf-8");

        return 'rss';
    }

    /**
     *  Rssμ
     *
     *  @access public
     *  @return string  ̾
     */
    function perform()
    {
        return null;
    }
}
?>
