<?php
/**
 *  Task.php
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @package    EthnaTask
 *  @version    $Id: skel.action.php,v 1.10 2006/11/06 14:31:24 cocoitiban Exp $
 */

/**
 *  Taskեμ
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @access     public
 *  @package    EthnaTask
 */
class Ethnatask_Form_Task extends EthnaTask_ActionForm
{
    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = true;

    /**
     *  @access private
     *  @var    array   ե
     */
    var $form = array(
        /*
        'sample' => array(
            // ե
            'type'          => VAR_TYPE_INT,    // ͷ
            'form_type'     => FORM_TYPE_TEXT,  // ե෿
            'name'          => 'ץ',      // ɽ̾

            // Хǡ(ҽ˥Хǡ¹Ԥޤ)
            'required'      => true,            // ɬܥץ(true/false)
            'min'           => null,            // Ǿ
            'max'           => null,            // 
            'regexp'        => null,            // ʸ(ɽ)

            // ե륿
            'filter'        => null,            // Ѵե륿ץ
        ),
        */
        'submit' => array(
            'name' => 'λˤ',
            'required' => false,
        ),
        'delete' => array(
            'type' => VAR_TYPE_STRING,
            'form_type' => FORM_TYPE_SUBMIT,
            'name' => '',
            'required' => false,
        ),
        'id' => array(
            'type' => VAR_TYPE_INT,
            'form_type' => FORM_TYPE_HIDDEN,
            'required' => true,
        ),
    );
}

/**
 *  Taskμ
 *
 *  @author     halt <halt.feits@gmail.com>
 *  @access     public
 *  @package    EthnaTask
 */
class Ethnatask_Action_Task extends EthnaTask_ActionClass
{
    /**
     *  Task
     *
     *  @access public
     *  @return string      ̾(ｪλʤnull, λʤfalse)
     */
    function prepare()
    {
        if (!$this->af->get('submit') && !$this->af->get('delete')) {
            //no action
        } else if ($this->af->validate() == 0) {
            if ($this->af->get('submit')) {
                return null;
            } else if ($this->af->get('delete')) {
                return $this->delete();
            }
        }

        $task = $this->db->getTaskFromId($this->af->get('id'));
        $this->af->setApp("task", $task);

        return 'task-detail';
    }

    /**
     * delete
     *
     * @access public
     */
    function delete()
    {
        $this->db->deleteTaskFromId($this->af->get('id'));
        $this->redirect();
        return null;
    }

    /**
     *  Taskμ
     *
     *  @access public
     *  @return string  ̾
     */
    function perform()
    {
        $this->db->completeTaskFromId($this->af->get('id'));
        $this->redirect();
        return null;
    }
}
?>
