<?php
/**
 * create table script
 *
 */
$queries[] = <<<EOD
CREATE TABLE task (
    id INTEGER PRIMARY KEY,
    user VARCHAR,
    name VARCHAR,
    rate INTEGER DEFAULT 0,
    comment VARCHAR,
    created_at INTEGER,
    updated_at INTEGER,
    deleted_at INTEGER DEFAULT 0,
    task_order INTEGER NOT NULL
);
EOD;

$db_file = './task/ethnatask.db';

if (file_exists($db_file)) {
    exit('error: database file exists!' . "\n");
}

$db = sqlite_open($db_file, 0666);
foreach ($queries as $query) {
    print("Execute query at\n{$query}\n");
    sqlite_query($db, $query);
}
?>
