<?php
/**
 * {$file_path}
 * 
 * smarty plugins for {$app_id}
 * 
 * @author BoBpp < bobpp@users.sourceforge.jp >
 * @package projBop.Ethna.Scaffold
 */
 
// Scaffoldѥ֥Ȥ
define('ETHNA_SCAFFOLD_MODELS', "__ethna_appObjects_proto");

/**
 * ǥΥ̾ɽ
 * 
 * sample:
 * <code>
 * {model_column model="user" column="name"}
 * </code>
 * <code>
 * 桼̾
 * </code>
 * 
 * @param string $model ǥ̾
 * @param string $column ̾
 */
function smarty_function_model_column($params, &$smarty)
{
	if (isset($params['model']) === false || isset($params['column']) === false) {
		return null;
	}
	
	if (isset($GLOBALS[ETHNA_SCAFFOLD_MODELS][$params['model']]) === false) {
		$controller =& Ethna_Controller::getInstance();
		$backend =& $controller->getBackend();
		$GLOBALS[ETHNA_SCAFFOLD_MODELS][$params['model']] =& $backend->getObject($params['model']);
	}
	$model =& $GLOBALS[ETHNA_SCAFFOLD_MODELS][$params['model']];
	
	if (method_exists($model, 'getColumnName')) {
		return $model->getColumnName($params['column']);
	} else {	
		return $params['column'];
	}
}

/**
 * ǥ̾ɽ
 * 
 * sample:
 * <code>
 * {model_name model="user"}
 * </code>
 * <code>
 * 桼
 * </code>
 * 
 * @param string $model ǥ̾
 */
function smarty_function_model_name($params, &$smarty)
{
	if (isset($params['model']) === false) {
		return null;
	}
	
	if (isset($GLOBALS[ETHNA_SCAFFOLD_MODELS][$params['model']]) === false) {
		$controller =& Ethna_Controller::getInstance();
		$backend =& $controller->getBackend();
		$GLOBALS[ETHNA_SCAFFOLD_MODELS][$params['model']] =& $backend->getObject($params['model']);
	}
	$model =& $GLOBALS[ETHNA_SCAFFOLD_MODELS][$params['model']];
	
	if (method_exists($model, 'getColumnName')) {
		return $model->getModelName();
	} else {	
		return $params['model'];
	}
}
?>
