<?php
/**
 *	{$app_path}
 *
 *	@author		{$author}
 *	@package	{$project_id}
 *	@version	$Id: skel.app_object.php,v 1.2 2006/03/07 16:23:18 fujimoto Exp $
 */

/**
 *	Base AppManager for {$project_id}
 *
 *	@author		{$author}
 *	@access		public
 *	@package	{$project_id}
 */
class {$project_id}_AppBase_AppManager extends Ethna_AppManager
{
	/** @var string Υޥ͡㤬ᥤǻȤǥ̾ */
	var $modelName = null;
	
	/**
	 * ץѥƥꥹȤ
	 * 
	 * @access public
	 * @param int $offset եå
	 * @param int $num 
	 * @return mixed (Array: ֥ȤΥץѥƥꥹ, Ethna::Error: 顼)
	 */
	function gets($offset=null, $num=null)
	{
		$model =& $this->backend->getObject($this->modelName);
		if (in_array('deleted_at', array_keys($model->getDef()))) {
			$filter = array(
				'deleted_at' => new Ethna_AppSearchObject(NULL, OBJECT_CONDITION_EQ),
			);
		} else {
			$filter = array();
		}
		
		$order = array(
			'id' => OBJECT_SORT_DESC,
		);
		
		$list = $this->getObjectList($this->modelName, $filter, $order, $offset, $num);
		if (Ethna::isError($list))  {
			return $list;
		}
		
		return $list[1];
	}
	
	/**
	 * ץѥƥꥹȤ
	 * 
	 * @access public
	 * @return mixed (array: ֥ȤΥץѥƥꥹ, Ethna::Error: 顼)
	 */
	function getAll()
	{
		return $this->gets();
	}
}

/**
 *	Base AppObject for {$project_id}
 *
 *	@author		{$author}
 *	@access		public
 *	@package	{$project_id}
 */
class {$project_id}_AppBase_AppObject extends Ethna_AppObject
{
    /**
     * ƥ֤ʥ֥Ȥɾ
     * 
     * @access public
     * @return boolean ɤ
     */
    function isActive()
    {
    	if (parent::isActive() === false) {
    		return false;
    	}
    	if (isset($this->prop_def['deleted_at']) && $this->get('deleted_at') != null) {
    		return false;
    	}
    	return true;
    }
    
    /**
     * ǥ̾Τ
     * 
     * @access public
     * @return string ǥ̾
     */
    function getModelName()
    {
    	$name = get_class($this);
		$UName = strtoupper(substr($name, strpos($name, '_')+1));
    	$def = "SCAFFOLD_MODEL_NAME_{$UName}";
    	
    	if (defined($def)) {
    		return constant($def);
    	} else {
    		return ucfirst($UName);
    	}
    }
    
    /**
     * ץѥƥι̾
     * 
     * @access public
     * @param string $key ץѥƥ̾
     * @return string ץѥƥι̾
     */
    function getColumnName($key)
    {
    	$name = get_class($this);
		$UName = strtoupper(substr($name, strpos($name, '_')+1));
		$ColumnUName = strtoupper($key);
    	$def = "SCAFFOLD_COLUMN_NAME_{$UName}_{$ColumnUName}";
    	
    	if (defined($def)) {
    		return constant($def);
    	} else {
    		return ucfirst($key);
    	}
    }
    
    /**
     * 쥳ɤɲä
     * 
     * @access public
     */
    function add()
    {
    	$date = date('Y-m-d H:i:s');
    	// ɲ
    	if (isset($this->prop_def['created_at'])) {
    		$this->set('created_at', $date);
    	}
    	// ǽ
    	if (isset($this->prop_def['updated_at'])) {
    		$this->set('updated_at', $date);
    	}
    	   	
    	return parent::add();
    }
    
    /**
     * 쥳ɤ򹹿
     * 
     * @access public
     */
    function update()
    {
    	if (isset($this->prop_def['updated_at'])) {
    	    $this->set('updated_at', date('Y-m-d H:i:s'));
    	}
    	return parent::update();
    }
    
    /**
     * 쥳ɤ
     * 
     * @access public
     */
    function remove()
    {
    	if (isset($this->prop_def['deleted_at'])) {
    		$this->set('deleted_at', date('Y-m-d H:i:s'));
    		return parent::update();
    	} else {
    		return parent::remove();
    	}
    }
}
?>
